; global addresses

!ifdef INCLUDE_ADDR !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_ADDR = 1
}

irq_downcount = $00
zptmp = $01
zpdst = $02
zpdsth = $03
zptxt = $04
zptxth = $05
optr = $06
optrh = $07
zploops = $08
phase_num = $09     ; 0..2: game menu, cast, movement
flag_phase = $0a    ; phase_num << 6: $00 game_menu, $04 cast_phase, $80 movement

color = $0b
menuitem = $0c
; $0d used by random
menutmp = $0e
Ordertmp = menutmp
Rangedtmp = menutmp ; $ff = dragon, $00 = other
menunum = $0f
menuloops = $10

joy_prev = $11  ; %000frldu
joy_value = $12 ; INPUT_*
joy_count = $13
joy_repeat = $14    ; 1 if debounced, 0 if first repeat, $ff if more repeats

; 0 .. AREA_SIZE - 1
acoord = $18    ; cursor / target coords
acoordprev = $19
scoord = $1f    ; start square of current spell / creature
ccoord = $20    ; current controlled entity coordinates
wcoord = $21    ; wizard coordinates

; $22..$29 used by random

player_i = $2a  ; 0..7
player_num = $2b    ; 2..8
player_offs = $2c   ; player_i offset to player_data
flag_player_cpu = $2d   ; $00 | $80
target_square_found = $2e   ; $00 | $80
lut_index = $2f   ; index to tbl_prio / tbl_target

round_count = $3f
world_chaos = $40
current_spell = $41 ; 0 -> none
current_spell_chance = $42  ; 0..9
temp_success_flag = $43     ; $00 | $80
temp_illusion_flag = $44    ; $00 | $80
temp_cast_amount = $45
num_spells = $46
best_spell = $47
mptr = $48
mptrh = $49
current_spell_range = $4a   ; + 1 for bcc comparison

; NOTE: consecutive addresses for [xy][12] in this order
temp_x1 = $50
temp_x2 = temp_x1 + 1 ; $51
temp_y1 = temp_x2 + 1 ; $52
temp_y2 = temp_y1 + 1 ; $53
; dx, dy == uint8 (abs)
temp_dx = $54
temp_dy = $55
; $56 used by random

; NOTE: consecutive addresses for [xy]i[12] in this order
; $40 if nonzero, $80 if negative
temp_xi1 = $57
temp_xi2 = temp_xi1 + 1 ; $58
temp_yi1 = temp_xi2 + 1 ; $59
temp_yi2 = temp_yi1 + 1 ; $5a

; d, di1, di2 == sint16 (only 9 bits used)
; NOTE: consecutive addresses for di[12] in this order
temp_di1 = $5b
temp_di2 = temp_di1 + 1 ; $5c
; NOTE: consecutive addresses for di[12]h in this order
temp_di1h = $5d
temp_di2h = temp_di1h + 1 ; $5e
temp_d = $5f
; $60 .. $70 used by random
temp_dh = $71

tcoord = $72    ; temp coords (during calculations)
pcoord = $73    ; previous coords (for redraw)
flag_anim = $74 ; los_blocked: $80 -> animate, $00 -> check LOS

Sfx_zp_base = $75   ; .. $7a

selected_creature = $7b
tmp_range_attack = $7c
tmp_movement_allowance = $7d
tmp_is_flying = $7e
tmp_engaged_flag = $7f
tmp_creature_id = $80
tmp_range_attack_val = $81
tmp_wizard_movement_allowance = $82
flying_target_found = $83
move_table_created = $84
has_wizard_moved = $85
distance_moved = $86
tmp_scoord = $87
tmp_acoord = $88
; $8b used by random

attacker = $90
defender = $91
attacking_val = $92
defending_val = $93
attacker_undead = $94   ; $ff | $00
defender_undead = $95   ; $ff | $00
attacker_modifier = $96
defender_modifier = $97

k_lstx = $c5    ; used by keyscan
; $c6   ; used by keyscan
; $cb   ; used by keyscan
; $f5   ; used by keyscan
; $f6   ; used by keyscan

; overlayed variables
; examine, CPU routines, destroy_all_creatures do not overlap
priority_offset = $f7
tmp_square_found = $f8
attacker_index = $f9
exdstmpy = $f9
enemy_creature = $fa
enemy_wizard = $fb
exdstmpa = $fb
exdstmpx = $fc

; used by random
kb_valtyp = $0d  ; data type flag, $FF = string, $00 = numeric
kb_index = $22  ; misc temp byte, 4b
kb_resho = $26  ; temp mantissa, 4b
kb_fac1 = $61  ; 6b
kb_bits = $68  ; FAC1 overflow
kb_fac2 = $69  ; 6b
kb_arisgn = $6f  ; FAC sign comparison
kb_facov = $70  ; FAC1 rounding
kb_rndx = $8b  ; RND() seed, 5b

stack_top = $1e0 ; leave room to top of page 1

; used by keyscan etc
; $277
; $278
kv_hibase = $288
; $289
kv_rptflg = $28a
; $28c
; $28d
; $28e
; $28f
; $290
kv_mode = $291

; $314
; $315
; $316
; $317
; $318
; $319

; $32a get vector
; $32b

vmatrix = $1000
charset = $8800
colorram = $9400 + (vmatrix & $200)

; 15x10 arena tables, $96 bytes
; arena_above has the creature ID (SPELL_KING_COBRA, ...), wizard ID (WIZARD_INDEX + 0..7) or 0 if empty
arena_above = $100  ; - $195
; arena_aflag has the creature owned and other bits (see AFLAG_MASK_* in arena.asm)
arena_aflag = $1e1  ; - $276
; arena_below has 0 or wizard ID of wiz in castle/tree/mount or creature ID of creature under goo
arena_below = $33c  ; - $3d1, casette buffer
; arena_bflag has 0 or creature ID of corpse or creature aflag of creature under goo
arena_bflag = vmatrix + ROWS * COLS
; arena_dead has flag for IS_DEAD and owner bits for corpse (former) owner
arena_dead = colorram + ROWS * COLS ; only 4 bits used

!if FAST_GETYX > 0 {
Variable_base = $5900
} else {
Variable_base = $5b00
}

player_names = Variable_base
player_data = player_names + NUM_PLAYERS_MAX * PNAME_LEN

; table of priorities for order_table (priority of .c prio_table)
tbl_prio = player_data + NUM_PLAYERS_MAX * PDATA_LEN
; table of ai targets (index of .c prio_table)
tbl_target = tbl_prio + AREA_SIZE

; tables for area coord -> screen, x/y
tbl_area_i_to_screen = tbl_target + AREA_SIZE
!if FAST_GETYX > 0 {
tbl_area_i_x = tbl_area_i_to_screen + AREA_SIZE
tbl_area_i_y = tbl_area_i_x + AREA_SIZE
Variable_end = tbl_area_i_y + AREA_SIZE
} else {
Variable_end = tbl_area_i_to_screen + AREA_SIZE
}

RAM_16k_end = $6000

!if Variable_end > RAM_16k_end {
!error "16k is not enough for data: ", * - RAM_16k_end
}
