; global constants

INCLUDE_GUARD = 0

!ifdef INCLUDE_CONST !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_CONST = 1
}

DEBUG_PRINT = 0
DEBUG_IRQ_LEN = 0
DEBUG_MAGIC_ALWAYS_WORKS = 0
DEBUG_AI_SPELL = 0
DEBUG_AI_MOVE = 0
DEBUG_ARENA_VIEW = 0
DEBUG_KEY = 0
DEBUG_EDITNAME = 0
DEBUG_JOY = 0

FAST_GETYX = 1

SOUND_VOLUME = 8

COLS = 22
ROWS = 16

AREA_W = 15
AREA_H = 10
AREA_SIZE = AREA_W * AREA_H
AREA_XOFF = 1
AREA_YOFF = 1

POS_AREA = AREA_YOFF * COLS + AREA_XOFF

POSX_INFOLINE = AREA_XOFF + AREA_W + 1
POSY_INFOLINE0 = 0
POS_INFOLINE = POSY_INFOLINE0 * COLS + POSX_INFOLINE
INFOLINE_W = COLS - AREA_W - AREA_XOFF * 2
INFOLINE_H = AREA_H + AREA_YOFF * 2
INFOOFFS_ATK = COLS * 0 + 4
INFOOFFS_RC = COLS * 1 + 2
INFOOFFS_RR = COLS * 1 + 4
INFOOFFS_DEF = COLS * 2 + 4
INFOOFFS_MOV = COLS * 3 + 4
INFOOFFS_MAN = COLS * 4 + 4
INFOOFFS_RES = COLS * 5 + 3
INFOOFFS_VAR = COLS * 6

POSY_STATUSLINE0 = AREA_YOFF + AREA_H + 1
POSY_STATUSLINE1 = AREA_YOFF + AREA_H + 1 + 1
POSY_STATUSLINE2 = AREA_YOFF + AREA_H + 1 + 2
POSY_STATUSLINE3 = AREA_YOFF + AREA_H + 1 + 3

NUM_PLAYERS_MIN = 2
NUM_PLAYERS_MAX = 8

COLOR_BLACK = 0
COLOR_WHITE = 1
COLOR_RED = 2
COLOR_CYAN = 3
COLOR_PURPLE = 4
COLOR_GREEN = 5
COLOR_BLUE = 6
COLOR_YELLOW = 7

SPELL_INDEX_NONE = $ff

CHAR_LAW = '^'
CHAR_NEUTRAL = '-'
CHAR_CHAOS = '*'
CHAR_DEAD = '.' ;$6f
CHAR_RAY = '{'
CHAR_MENUCURSOR = '>'

WIZARD_INDEX = 42  ; SPELL_WALL + 1 ?

NUM_SPELLS_MAX = 21

; wizard struct definition
PDATA_OFFS_COMBAT_DEF = $00
;!by (.combat << 4) | (.defence)
PDATA_OFFS_RANGED = $01
;!by (.rangedc << 4) | (.rangedr)
PDATA_OFFS_MOV_MAN = $02
;!by (.movement << 4) | (.manvr)
PDATA_OFFS_MRES = $03
PDATA_OFFS_ABILITY = $04

PDATA_OFFS_FLAGS1 = $05
PDATA_MASK_FLAGS1_KNIFE  = %00000010
PDATA_MASK_FLAGS1_SWORD  = %00000100
PDATA_MASK_FLAGS1_SHADOW = %00001000
PDATA_MASK_FLAGS1_DEAD   = %00010000
PDATA_MASK_FLAGS1_WINGS  = %00100000
PDATA_MASK_FLAGS1_SHIELD = %01000000
PDATA_MASK_FLAGS1_ARMOUR = %10000000

PDATA_OFFS_PTYPE = $06
; 0 - human
; 1..8 - cpu 1..8

PDATA_OFFS_FLAGS2 = $07
PDATA_MASK_FLAGS2_ILLUSION = %00000001

PDATA_OFFS_TIMID = $08

PDATA_OFFS_SELECTED_SPELL = $09
PDATA_OFFS_SPELL_COUNT = $0a
PDATA_OFFS_SPELLS = $0b ; 21 spells

PDATA_LEN = PDATA_OFFS_SPELLS + NUM_SPELLS_MAX

PNAME_LEN = 8
