; start of turn menu

!ifdef INCLUDE_GAMEMENU !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_GAMEMENU = 1
}

!zn Gamemenu {

.SPELLMENU_YOFF = 4

.text_gamemenu:
!tx "Select ", TTOK_SPELL_, 0
!tx "Examine Board", 0
!tx TTOK_CONTINUE, " Game", 0
!tx 0

; y = player_i
; color = wizard color
game_menu:
    jsr unselect_spell
!if DEBUG_KEY > 0 {
    jsr set_current_player_index
}
.game_menu_loop:
    ; setup printing
    jsr print_clear_status
    jsr print_clear_info
    jsr print_setup_dst_statusline

    ldy player_i
    jsr print_wizard_name

    ; print world chaos
    ; put ^/* after max name len world_chaos/2 times (and not over screen edge)
    lda #COLOR_CYAN
    sta color
    ldx #CHAR_LAW
    lda world_chaos
    bpl +
    ldx #CHAR_CHAOS
    pha
    lda #COLOR_PURPLE
    sta color
    pla
    eor #$ff
    clc
    adc #1
+   lsr
    beq +
    tay
    txa
    ldx #PNAME_LEN + 1
-   pha
    jsr print_char_dst_x
    pla
    cpx #COLS
    beq +
    dey
    bne -
+

    ldx #<.text_gamemenu
    ldy #>.text_gamemenu
    jsr statusmenu
    cpy #1
    bcc .game_menu_select
    beq .game_menu_examine
    ; continue
    clc
    rts

.game_menu_select:
    jsr spell_menu
    jmp .game_menu_loop

.game_menu_examine:
    lda #$ff
    jsr arena_view
!if DEBUG_KEY > 0 {
    bcc +++
!if 0 {
    ; teleport wizard to square
    ldx wcoord
    lda arena_below,x
    beq +
    lda #0
    sta arena_below,x
    sta arena_bflag,x
    beq ++
+   lda #0
    sta arena_above,x
    sta arena_aflag,x
++  ldy acoord
    lda arena_above,y
    bne +
    lda player_i
    sta arena_aflag,y
    clc
    adc #WIZARD_INDEX
    sta arena_above,y
    bne ++
+   lda player_i
    sta arena_bflag,y
    clc
    adc #WIZARD_INDEX
    sta arena_below,y
++  jsr arena_draw
}
!if 1 {
    ; toggle alive/dead
    ldx acoord
    lda arena_above,x
    beq +++
    lda arena_dead,x
    eor #DEAD_MASK_IS_DEAD
    sta arena_dead,x
    jsr arena_draw
}
+++
}
    jsr arena_erase_cursor
    jmp .game_menu_loop


.text_illusion:
!tx "Illusion?",0

spell_menu:
    ; get spell count and ptr
    jsr get_wizard_spells
    sta menunum

    ldy #0
    sty menuitem

.spell_menu_draw:
    ; setup printing
    jsr print_setup_dst_area

    ; clear area
    jsr print_clear_area

    ; print static cursor
    lda #COLOR_CYAN
    sta color
    ldx #(COLS * .SPELLMENU_YOFF)
    lda #CHAR_MENUCURSOR
    jsr print_char_dst_x

    lda #1
    jsr print_setup_dst_add_a

    ; print spell names
    lda #AREA_H
    sta menuloops

    lda #COLOR_WHITE
    sta color

    lda menuitem
    sec
    sbc #.SPELLMENU_YOFF
    sta menutmp

--  ldy menutmp
    bmi +++
    cpy menunum
    bcs +++
    lda (optr),y
    ; TODO color based on type/chance?
    ; print law/neutral/chaos char
    pha
    asl
    tay
    lda spelldata_packed,y
    lsr
    lsr
    lsr
    lsr
    tax
    ldy #CHAR_NEUTRAL
    lda tbl_spelldata_chaos,x
    bpl +
    ldy #CHAR_CHAOS
    bne ++  ; bra
+   beq ++
    ldy #CHAR_LAW
++  ldx #0
    tya
    jsr print_char_dst_x
    lda #1
    jsr print_setup_dst_add_a
    pla
    jsr print_spellname_dst_ready
    lda #-1
    jsr print_setup_dst_sub_a
+++
    jsr print_setup_dst_next_line
    inc menutmp
    dec menuloops
    bne --

    ; print data on selected spell
    ldy menuitem
    lda (optr),y
    sta current_spell
    jsr set_current_spell_chance
    jsr examine_spell

.spell_menu_input:
    jsr get_input_wait_irq
    beq .spell_menu_input

    ldy menuitem
    cmp #INPUT_SELECT
    bne ++

    ; set chosen spell
    ldx player_offs
    tya
    sta player_data + PDATA_OFFS_SELECTED_SPELL,x

    ; check if creature
    lda (optr),y
    cmp #SPELL_KING_COBRA
    bcc .spell_menu_done
    cmp #SPELL_GOOEY_BLOB
    bcs .spell_menu_done

    ; ask if illusion
    ; erase cursor
    lda #' '
    sta vmatrix + POS_AREA + COLS * .SPELLMENU_YOFF

    jsr print_clear_status
    ldx #<.text_illusion
    ldy #>.text_illusion
    stx zptxt
    sty zptxth
    jsr print_setup_dst_statusline
    jsr print_packed_dst_ready
    ldx #<text_noyes
    ldy #>text_noyes
    jsr statusmenu
    cpy #0
    beq .spell_menu_done

    ldx player_offs
    lda player_data + PDATA_OFFS_FLAGS2,x
    ora #PDATA_MASK_FLAGS2_ILLUSION
    sta player_data + PDATA_OFFS_FLAGS2,x

.spell_menu_done:
    ; clear status and info
    jsr print_clear_status
    jsr print_clear_info
    ; redraw arena
    jsr arena_draw
    rts

++  cmp #INPUT_U
    bne ++
    dey
    bpl +
    ldy menunum
    dey
+   sty menuitem
    jmp .spell_menu_draw

++  cmp #INPUT_D
    bne .spell_menu_input
    iny
    cpy menunum
    bne +
    ldy #0
+   sty menuitem
    jmp .spell_menu_draw

} ; !zn Gamemenu
