; player setup menu and init

!ifdef INCLUDE_PLAYERS !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_PLAYERS = 1
}

!zn Players {

.TEXT_OFF_PLAYERS = 1

.text_players:
!tx "Players?", 0
.LEN_text_players = * - .text_players - 1

.text_human:
!tx "Human"
.text_cpu:
!tx "CPU  "

create_players:
    lda #COLOR_RED
    jsr set_arena_border_color
    jsr print_clear_area

    ; print static text
    lda #COLOR_WHITE
    sta color

    ldx #<.text_players
    ldy #>.text_players
    stx zptxt
    sty zptxth

    ldx #<(vmatrix + POS_AREA + .TEXT_OFF_PLAYERS)
    ldy #>(vmatrix + POS_AREA + .TEXT_OFF_PLAYERS)
    jsr print_packed_xy

    ; setup further printing
    jsr print_setup_dst_area

    ; print all current players
    lda #0
    sta menuitem
    sta player_i
-   lda player_i
    cmp player_num
    beq +
    jsr .create_players_print_player
    inc player_i
    bne -   ; bra
+

.create_players_loop:
    lda #COLOR_CYAN
    sta color

    ; draw cursor
    ldy menuitem
    ldx text_line_area_offs,y
    lda #CHAR_MENUCURSOR
    jsr print_char_dst_x

    ; print number of players
    ldx #(.LEN_text_players + 2)
    lda player_num
    jsr print_num_dst_x

    ; get input and churn random
.create_players_input:
    jsr get_random_10
    ; flash cursor?
    jsr get_input_wait_irq
    beq .create_players_input
    ldy menuitem

    cmp #INPUT_SELECT
    bne ++
    cpy #0
    beq +
    jsr .create_players_edit_name
    jmp .create_players_loop
+   jmp init_players

++  cmp #INPUT_U
    bne ++
    jsr text_erase_cursor
    dey
    bpl +
    ldy player_num
+   sty menuitem
    jmp .create_players_loop

++  cmp #INPUT_D
    bne ++
    jsr text_erase_cursor
    iny
    cpy player_num
    bcc +
    beq +
    ldy #0
+   sty menuitem
    jmp .create_players_loop

++  cmp #INPUT_L
    bne ++
    cpy #0
    bne +
    ; change number of players
    ldy player_num
    cpy #NUM_PLAYERS_MIN
    beq .create_players_input
    dey
    sty player_num
    sty player_i
    jsr .create_players_erase_player
    jmp .create_players_loop
+   ; change player type
    dey
    ldx wizard_offs,y
    lda player_data + PDATA_OFFS_PTYPE,x
    bne +
    jmp .create_players_input
+   dec player_data + PDATA_OFFS_PTYPE,x
.create_players_change_type:
    sty player_i
    tya
    jsr .create_players_print_player
    jmp .create_players_loop

++  cmp #INPUT_R
    bne ++
    cpy #0
    bne +
    ; change number of players
    ldy player_num
    cpy #NUM_PLAYERS_MAX
    beq .create_players_input
    sty player_i
    tya
    iny
    sty player_num
    jsr .create_players_print_player
    jmp .create_players_loop
+   ; change player type
    dey
    ldx wizard_offs,y
    lda player_data + PDATA_OFFS_PTYPE,x
    cmp #8  ; AI_LEVEL_MAX
    bne +
    jmp .create_players_input
+   inc player_data + PDATA_OFFS_PTYPE,x
    jmp .create_players_change_type

++  jmp .create_players_input


; y = player_i = player index
.create_players_erase_player:
    lda #0
    beq .create_players_print_player_in ; bra
    ; fall through

; a = player_i = player index
.create_players_print_player:
    tay
    lda wizard_color,y
.create_players_print_player_in:
    sta color

; y = player_i = player index
; color = color
.create_players_print_player_do:
    lda #PNAME_LEN
    sta zploops
    ldx text_line_area_offs + 1,y
    inx
    tya
;!if PNAME_LEN != 8 {
;!error "fixme"
;}
    asl
    asl
    asl
    tay
-   lda player_names,y
    jsr print_char_dst_x
    iny
    dec zploops
    bne -
    lda #' '
    jsr print_char_dst_x
    ldy player_i
    lda wizard_offs,y
    tay
    lda player_data + PDATA_OFFS_PTYPE,y
    sta zptmp
    bne +
    ldy #0
    beq ++  ; bra
+   ldy #(.text_cpu - .text_human)
++  lda #5  ; len("Human")
    sta zploops
-   lda .text_human,y
    jsr print_char_dst_x
    iny
    dec zploops
    bne -
    dex
    lda zptmp   ; PTYPE
    beq +
    jsr print_num_dst_x
+   rts


; in:
; y = menuitem = player index + 1
.create_players_edit_name:
    jsr text_erase_cursor
    dey
    sty player_i

    ; erase current name (from screen)
    lda wizard_color,y
    sta color
    lda #PNAME_LEN
    sta zploops
    ldx text_line_area_offs + 1,y
    inx
-   lda #' '
    jsr print_char_dst_x
    dec zploops
    bne -

    ; setup temp name buffer
    lda #' '
    ldx #PNAME_LEN - 1
-   sta tbl_target,x
    dex
    bpl -

.create_players_edit_name_loop:
    ; set cursor
    ldy player_i
    lda text_line_area_offs + 1,y
    sec ; +1
    adc zploops ; len
    tax
    lda #' ' | $80
    jsr print_char_dst_x

!if DEBUG_EDITNAME > 0 {
    ldy #8
    lda zploops
    jsr print_hex
    ldy player_i
}

-   jsr get_input_text
    beq -
!if DEBUG_EDITNAME > 0 {
    ldy #3
    pha
    jsr print_hex
    pla
    sta vmatrix + 6
}
    ldy player_i
    cmp #$ff    ; cancel
    beq .create_players_edit_name_nope
    cmp #$fe    ; done
    beq .create_players_edit_name_done_checks
    cmp #$fd    ; delete
    bne ++
    ; delete char
    ldx zploops ; len
    beq -
    dex
    lda #' '
    sta tbl_target,x
    stx zploops ; len
    ; erase cursor
    inx ; +1
    txa
    sec ; +1
    adc text_line_area_offs + 1,y
    tax
    lda #' '
    jsr print_char_dst_x
    jmp .create_players_edit_name_loop
++  ; valid char, add it
    ldx zploops
    cpx #PNAME_LEN
    beq -
    sta tbl_target,x
    ; print it
    pha
    txa
    sec ; +1
    adc text_line_area_offs + 1,y
    tax
    pla
    jsr print_char_dst_x
    inc zploops
    jmp .create_players_edit_name_loop

.create_players_edit_name_done_checks:
    ; if length > 0 then accept name
    ldx zploops
    beq .create_players_edit_name_nope
+   tya
    asl
    asl
    asl
    tay
    ldx #0
-   lda tbl_target,x
    sta player_names,y
    iny
    inx
    cpx #PNAME_LEN
    bne -

.create_players_edit_name_nope:
    ; draw name
    ldy player_i
    jmp .create_players_print_player_do


!macro playerinitpos .x, .y {
!by (.x) + (.y) * AREA_W
}

.position_table:
+playerinitpos $1, $4
+playerinitpos $d, $4
!by 0, 0, 0, 0, 0, 0
+playerinitpos $7, $1
+playerinitpos $1, $8
+playerinitpos $d, $8
!by 0, 0, 0, 0, 0
+playerinitpos $1, $1
+playerinitpos $d, $1
+playerinitpos $1, $8
+playerinitpos $d, $8
!by 0, 0, 0, 0
+playerinitpos $7, $0
+playerinitpos $0, $3
+playerinitpos $e, $3
+playerinitpos $3, $9
+playerinitpos $b, $9
!by 0, 0, 0
+playerinitpos $7, $0
+playerinitpos $0, $1
+playerinitpos $e, $1
+playerinitpos $0, $8
+playerinitpos $7, $9
+playerinitpos $e, $8
!by 0, 0
+playerinitpos $7, $0
+playerinitpos $1, $1
+playerinitpos $d, $1
+playerinitpos $0, $6
+playerinitpos $e, $6
+playerinitpos $4, $9
+playerinitpos $a, $9
!by 0
+playerinitpos $0, $0
+playerinitpos $7, $0
+playerinitpos $e, $0
+playerinitpos $0, $4
+playerinitpos $e, $4
+playerinitpos $0, $9
+playerinitpos $7, $9
+playerinitpos $e, $9

init_players:
    jsr print_clear_area
    jsr print_clear_status
    lda #0
    tax
    sta player_i
.init_players_loop:
    lda player_i
    cmp player_num
    bne +
    rts
+
    ; x is at offset 0 of player_data[i]
    lda player_data + PDATA_OFFS_PTYPE,x
    sta zptxt   ; cpulvl
    lsr
    sta zptxth  ; (cpulvl>>1)

    ; combat & defence: (GetRand(10)>>1) + 1 + (cpulvl>>1)
    jsr get_random_10
    lsr
    sec ; + 1
    adc zptxth ; + (cpulvl>>1)
    asl
    asl
    asl
    asl
    sta zptmp
    jsr get_random_10
    lsr
    sec ; + 1
    adc zptxth ; + (cpulvl>>1)
    ora zptmp
    sta player_data,x
    inx

    ; ranged = 0
    lda #0
    sta player_data,x
    inx

    ; movement = 1
    ; manuouverability = (cpulvl>>2) + (GetRand(10)>>1) + 3
    jsr get_random_10
    lsr
    clc
    adc #3
    sta zptmp
    lda zptxth ; + (cpulvl>>1)
    lsr
    adc zptmp
    ora #$10
    sta player_data,x
    inx

    ; magic res: (GetRand(10)>>1) + 6
    jsr get_random_10
    lsr
    clc
    adc #6
    sta player_data,x
    inx

    ; ability; if (((cpulvl>>1) + GetRand(10)) >= 5) players[loop].ability = GetRand(10)>>2;
    lda #0
    sta player_data,x
    jsr get_random_10
    clc
    adc zptxth ; (cpulvl>>1)
    cmp #5
    bcc +
    jsr get_random_10
    lsr
    lsr
    sta player_data,x
+
    inx

    ; flags1
    lda #0
    sta player_data,x
    inx

    ; player type
    inx

    ; flags2
    ;lda #0
    sta player_data,x
    inx

    ; timid
    ;lda #0
    sta player_data,x
    inx

    ; selected spell
    ;lda #0
    sta player_data,x
    inx

    ; spell count: min(cpulvl + (GetRand(10)>>1) + 11, NUM_SPELLS_MAX - 1);
    jsr get_random_10
    lsr
    clc
    adc #11
    adc zptxt   ; cpulvl
    cmp #NUM_SPELLS_MAX
    bcc +
    lda #NUM_SPELLS_MAX - 1
+   sta player_data,x
    sta zploops
    sta zptxth  ; number of spells
    stx zptmp
    inx

    ; setup for ordering
    txa
    clc
    adc #<player_data
    sta zpdst
    lda #>player_data
    adc #0
    sta zpdsth

    ; generate spells
    lda #SPELL_DISBELIEVE
    sta player_data,x
    inx

-   lda #$ff
    jsr get_random_a
    and #$3f
    cmp #SPELL_KING_COBRA
    bcc -
    cmp #SPELL_RAISE_DEAD + 1
    bcs -
    sta player_data,x
    inx
    dec zploops
    bne -

    ; set priorities = $ff - spell id
    ldx zptmp
    inx
    ldy #0
-   lda #$ff
    sec
    sbc player_data,x
    sta tbl_prio,y
    inx
    iny
    cpy zptxth
    bne -

    ; order table for player's benefit (CPU reorders on do_ai_spell)
    ldx zpdst
    ldy zpdsth
    lda zptxth
    jsr order_table

    ; set player to arena
    lda player_num
    sec
    sbc #2
    asl
    asl
    asl
    adc player_i
    tay
    lda .position_table,y
    tay
    lda player_i
    sta arena_aflag,y
    ; clc
    adc #WIZARD_INDEX
    sta arena_above,y

    ; set x to next base
    lda zptmp
    clc
    adc #PDATA_LEN - PDATA_OFFS_SPELL_COUNT
    tax

    inc player_i
    jmp .init_players_loop

    rts

} ; !zn Players
