; misc. utility functions and tables

!ifdef INCLUDE_UTIL !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_UTIL = 1
}

!zn Util {

bitmask:
!by $80, $40, $20, $10, $08, $04, $02, $01, 0

; a = frames
delay:
    sta irq_downcount
-   lda irq_downcount
    bne -
    rts


; in:
; a = count
; tbl_prio = priorities
order_table_target:
    ldx #<tbl_target
    ldy #>tbl_target
; x:y -> table
order_table:
    sec
    sbc #1
    bcs +
    ; zero items, quit
    rts
+   sta zploops

    stx .order_table_smc_l0
    stx .order_table_smc_l1
    sty .order_table_smc_h0
    sty .order_table_smc_h1
    inx
    bne +
    iny
+   stx .order_table_smc_l0p1
    stx .order_table_smc_l1p1
    sty .order_table_smc_h0p1
    sty .order_table_smc_h1p1

    ldx #0
    stx .order_table_outer_loops

.order_table_outer:
.order_table_outer_loops = * + 1
    ldx #0
    cpx zploops
    beq .order_table_done

    ldy #0
    sty Ordertmp    ; clear amount of swapped items
.order_table_inner:
    lda tbl_prio,y      ; p1
    cmp tbl_prio + 1,y  ; p2
    bcs +   ; p1 >= p2

    ; p1 <-> p2
    tax ; x = p1
    lda tbl_prio + 1,y  ; a = p2
    sta tbl_prio,y  ; p1 <- p2
    txa
    sta tbl_prio + 1,y  ; p2 <- p1

    ; v1 <-> v2
.order_table_smc_l0 = * + 1
.order_table_smc_h0 = * + 2
    ldx $1000,y      ; x = v1
.order_table_smc_l0p1 = * + 1
.order_table_smc_h0p1 = * + 2
    lda $1000 + 1,y  ; a = v2
.order_table_smc_l1 = * + 1
.order_table_smc_h1 = * + 2
    sta $1000,y  ; v1 <- v2
    txa
.order_table_smc_l1p1 = * + 1
.order_table_smc_h1p1 = * + 2
    sta $1000 + 1,y  ; v2 <- v1

    ; count amount of swapped items
    inc Ordertmp
+   iny
    cpy zploops
    bne .order_table_inner

    ; if no swapped items then sorting is done
    lda Ordertmp
    beq .order_table_done

    inc .order_table_outer_loops
    bne .order_table_outer  ; bra

.order_table_done:
    rts

} ; !zn Util
